<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Symfony\Component\HttpFoundation\Response;
use Illuminate\Support\Facades\Auth;

class IdleTimeout
{
    /**
     * Handle an incoming request.
     *
     * @param  \Closure(\Illuminate\Http\Request): (\Symfony\Component\HttpFoundation\Response)  $next
     */
    public function handle(Request $request, Closure $next): Response
    {
        if (Auth::check()) {

            $timeout = 1800; // 15 minit (900 saat)

            if (session()->has('last_activity')) {

                if (time() - session('last_activity') > $timeout) {
                    Auth::logout();
                    session()->invalidate();
                    return redirect('/login')->with('message', 'Session expired.');
                }
            }

            session(['last_activity' => time()]);
        }

        return $next($request);
    }
}
